## +brace.tgz

=== Makefile ===
#!/usr/bin/make -f

include .Make.conf

BRACE_STANDALONE=

all: !README dotbuild

!README: debian/changelog
	vers=`vers`; <\!README sed "s/([0-9][^)]*)/($$vers)/g" >.README.new
	mv .README.new !README

tgz:
	tgz+ .
	chmod go+r .brace.tgz

dotbuild: cp
	cd .build && $(MAKE) build
cp:
	mkdir -p .build
	-if cp --help 2>&1 | grep -- '-a' >/dev/null; then opt=-afl; else opt=-pfR; fi; cp $$opt .Make.conf .sh.conf * .build/ 2>/dev/null
	#mkdir -p .build/lib/debug
build:
	cd exe && $(MAKE) boot
	cd lib && $(MAKE)
	cd exe && $(MAKE)
	#cd util && $(MAKE)
clean:
	cd exe && $(MAKE) clean
	cd lib && $(MAKE) clean
	cd eg && $(MAKE) clean
	cd util && $(MAKE) clean
	rm -rf .build
install: .build
	#cp .build/lib/$(SONAME) .build/util
	$(INSTALL) -d "$(libdir)" "$(perldir)" || true
	$(INSTALL) -m 644 lib/bk "$(libdir)"
	cp -pR perl/* "$(perldir)"
	PERL5LIB= perl -MIO::String -e '' 2>/dev/null || cp -pR cpan/IO "$(perldir)"
	cd .build/exe && $(MAKE) install
	cd .build/lib && $(MAKE) install

uninstall:
	cd .build/exe && $(MAKE) uninstall
	cd .build/lib && $(MAKE) uninstall
	rm -f '$(libdir)'/bk
	for D in `ls perl`; do rm -rf '$(perldir)'/"$$D"; done  # XXX this could trash other Brace::* packages
	rmdir '$(libdir)' '$(includedir)' '$(perldir)' '$(bindir)' '$(realprefix)' || true

distclean: clean
	rm .Make.conf .sh.conf

.PHONY: dotbuild build clean install distclean

=== eg/Makefile ===
# just for cleaning at the moment!

include ../.Make.conf

build:
	@echo examples can be run directly, no need to run make
clean:
	bk-clean
#	find . -type f \( -perm -u+x -o -perm -g+x -o -perm -o+x \) | xargs file | grep ELF | sed 's/:.*//' | xargs rm -f

=== exe/Makefile ===
include ../.Make.conf

CFLAGS=$(EXE_CFLAGS)
LDFLAGS=$(EXE_LDFLAGS)
LDLIBS=$(EXE_LDLIBS)

# - for win32; can assume there was nothing needful in PERL5LIB  :)

build: boot bx$(EXE) bbx$(EXE) b1$(EXE) bb1$(EXE)
boot: brace$(EXE) .mk_foo_stamp .mk_bar_stamp .mk_baz_stamp

brace.c: brace.b
	<brace.b b2b0 | b02b1 | brace >brace.c
brace$(EXE): brace.o
	echo $(PERL5LIB)
	echo $(BRACE_LIB)
	$(CC) $(LDFLAGS) $(CFLAGS) -o brace brace.o $(LDLIBS)
	@<brace.b b2b0 | b02b1 | brace >.brace.test.c
#	@../util/vd brace.c .brace.test.c || . ../util/fail "TEST FAILED! brace is broken!"
	@echo "brace works ok, hopefully"

bx$(EXE): bx.b ../lib/$(SONAME)
	br bx.b bx$(EXE)
bbx$(EXE): bx$(EXE)
	lnorcp bx$(EXE) bbx$(EXE)

b1$(EXE): b1.b ../lib/$(SONAME)
	br b1.b b1$(EXE)
bb1$(EXE): b1$(EXE)
	lnorcp b1$(EXE) bb1$(EXE)

.mk_foo_stamp: brace_foo
	brace_mk_exes brace_foo
	touch .mk_foo_stamp
.mk_bar_stamp: brace_bar
	brace_mk_exes brace_bar
	touch .mk_bar_stamp
.mk_baz_stamp: brace_baz
	brace_mk_exes brace_baz
	touch .mk_baz_stamp

clean:
	< exe_types perl -ne 'chomp; s/\r//g; s/.*\t//; unlink $$_';
	rm -f .mk_foo_stamp .mk_bar_stamp .mk_baz_stamp brace brace.exe bx bx.exe bbx bbx.exe brace.o brace.bh bx.bh .brace.1 .brace.2 .brace.test.c .bx.1 .bx.2 .bx.bak .bx.b1 .bx.c .bx.log .bx.b.xbak b1 b1.exe bb1 bb1.exe .b1.bak .b1.c .b1.b.xbak .b1.b1 .b1.bak2

install: build
	$(INSTALL) -d '$(bindir)' || true
	$(INSTALL) `../util/lsx .` '$(bindir)'
	$(INSTALL) -m 644 brace_env br_env_dev br_env_run '$(bindir)'
	lnorcp '$(bindir)/br' '$(bindir)/bbr'
	lnorcp bx$(EXE) '$(bindir)/bbx$(EXE)'
	lnorcp b1$(EXE) '$(bindir)/bb1$(EXE)'

uninstall:
	for F in `../util/lsx`; do rm -f '$(bindir)'/"$$F" ; done
	rm -f '$(bindir)/bbr' '$(bindir)/bbx$(EXE)' '$(bindir)/b1$(EXE)' '$(bindir)/bb1$(EXE)'
	rmdir '$(bindir)' || true

.PHONY: build boot clean install

=== util/Makefile ===
include ../.Make.conf

CFLAGS=$(EXE_CFLAGS)
LDFLAGS=$(EXE_LDFLAGS)
LDLIBS=$(EXE_LDLIBS)

build: install$(EXE)

install$(EXE): install.b $(BRACE_SO)/$(SONAME)
	br install.b install$(EXE)

clean:
	rm -f install$(EXE)

.PHONY: build boot clean

=== eg/cow/Makefile ===
cow.so: cow.c
	$(CC) -Wall -o$@ -s -shared -ldl $^

=== debian/changelog ===
brace (0.9.9~wip) unstable; urgency=low

  * fixed problems with MIT-SHM cleanup, now it cleans up even if signalled
  * got it to compile on mingw again
  * add line numbers by default now
  * fixed parsing bug with ^line ... in Process / eg/wordwrap
  * almost all of the graphics demos work on mingw
  * event handling and yukon on mingw
  * WIP X keysyms on mingw
  * re-ported to netbsd and freebsd
  * TODO full screen on mingw
  * TODO text and show on mingw
  * FIXME b1 on mingw
  * FIXME error on mingw doesn't seem to cause a proper exit

 -- Sam Watkins <sam@nipl.net>  Sat, 14 Nov 2009 22:27:34 +1100

brace (0.9.8) unstable; urgency=low

  * eg/tachyon httpd
  * select-based IO for coroutines, sendfile and epoll for Linux
  * graphics peeking - eg/shinytext
  * output different image files and create animated gifs!

 -- Sam Watkins <sam@nipl.net>  Wed, 11 Mar 2009 05:36:17 +0800

brace (0.9.7) unstable; urgency=low

  * fixing to work with msys
    - fixed path.b to use both / and \ in win32
  * brace now builds cleanly with both msys+mingw and unxutils+mingw on win32
  * added a "make uninstall" target
  * I got mk and brace_mk_cc / Brace::ResolveDeps working better, while trying
    to build geon.
  * includes GL graphics for win32
  * fixed brace so that it runs on linux again! some troubles with curses.
  * made gr buf an x-shm-pixmap so can poke directly, for new eg/pretty.b demo
  * wrote qtrig.b (quick trig) for eg/pretty.b
  * wrote sleep_step and asleep
  * wrote bm routines (benchmark)
  * fixed linux/sound dsp_buf was allocate too big, now synth works better
  * always use -D_FILE_OFFSET_BITS=64
  * always use -Wextra - found lots of bugs in libb when I added this!
  * use --pedantic --std=gnu99
  * added priq, timeout, locking, poll
  * fixed bx to use a lockfile, and prevent multiple compilation attempts!
  * added b1 for running one-liners

 -- Sam Watkins <sam@nipl.net>  Fri, 30 Jan 2009 14:50:32 +0800

brace (0.9.6) unstable; urgency=low

  * compiling and working on gnu/linux, netbsd, openbsd, freebsd, gnu/hurd and
    hopefully still on mingw with unxutils ...

 -- Sam Watkins <sam@nipl.net>  Thu, 28 Sep 2006 18:03:49 +1000

brace (0.9.5) unstable; urgency=low

  * compiling and working on gnu/linux, netbsd, openbsd and mingw with
    unxutils ...

 -- Sam Watkins <sam@nipl.net>  Thu, 28 Sep 2006 14:07:53 +1000

brace (0.9) unstable; urgency=low

  * fixed hash.b so it works, with hashtest.b
  * fixed bug in tokenizer with floats
  * TODO remove loudmouth / jabber support, remove C++ library
  * there is a bug in stdc.b   or in gcc/ld/libc6 ?
    workaround: removed "Atexit" throughout
  * extern "C" blocks were broken, fixed
  * persuaded to support other compilers, specifically tcc.
    let(...) won't work yet due to GNU-only "typeof".. wait, yes it does!
    woot! :)
  * make possible to disable the "incredibly dodgy and only partly complete
    line number" thing.  improved that a bit too
  * fixed build process for brace components: brace_rm_comments_blank, etc
  * working on parse.b  :O)  going well  :O)
  * renamed "vector" to "vec"  maybe do "buffer" to "buf" also?
    or should it be "vect" or "vectr" or something longish?  need a standard
    for type names vs. default variable names.  I guess vec -> v  buf -> b
    are ok.
  * fixed brace_mk_cc recursion problem to get "graph" to work
  * examples: I put almost all the brace code I've written in eg/  :)
  * fixed various issues that stopped it working with gcc 4
  * fixed ResolveDeps.pm to get "rocks" (C++) to work again
  * fixed mk etc to get "geon" to work again :)
  * fixed Include.pm to get "graph" to work :)
  * hacked around a syntax change in GNU "find" in utils/lsx and mk-clean
  * renamed deque to deq
  * added some functions from examples to libraries
  * more work on hashtables, split, tsv, for_foo etc.
  * sym.b, tok.b (maybe tok.b is not useful)
  * clean the eg directory
  * fixed a bug (use va_copy), now it works on powerpc :)
  * porting so it can work on mingw and linux and *bsd...
  * new "use" semantic will load ALL matching *.b files,
    and can also add a directory to the search path.
    The orignal intention of this is to support porting cleanly.
  * sort of fixed bug in Strip.pm with array typedefs
  * fixed strdup -> Strdup

 -- Sam Watkins <sam@nipl.net>  Sun, 23 Apr 2006 16:51:52 +1000

brace (0.8) unstable; urgency=low

  * added an incredibly dodgy and only partly complete line number
    preservation thingy brace_number_lines.  hopefully this will help with
    debugging more often than it causes utter confusion :p

 -- Sam Watkins <sam@nipl.net>  Sat, 29 Oct 2005 09:53:49 +0000

brace (0.7) unstable; urgency=low

  * fix dodgy cgi-png stuff so it at least works, for cgi-demo.b

 -- Sam Watkins <sam@nipl.net>  Tue, 27 Sep 2005 11:53:50 +0000

brace (0.6) unstable; urgency=low

  * fixed a bug in brace_files introduced by the last "fix" :p

 -- Sam Watkins <sam@nipl.net>  Fri, 16 Sep 2005 10:04:49 +0000

brace (0.5) unstable; urgency=low

  * fixed a bug in brace_files, it was only finding files called *.b, etc,
    not executable files with a #!/lang/b, etc.

 -- Sam Watkins <sam@nipl.net>  Fri, 16 Sep 2005 09:40:33 +0000

brace (0.4) unstable; urgency=low

  * changed from GPL to public-domain

 -- Sam Watkins <sam@nipl.net>  Wed,  7 Sep 2005 09:55:02 +0000

brace (0.3) unstable; urgency=low

  * fix bug with rgb() in gr.b
  * fix C++ include path so that "rocks" compiles again
  * started work on e2b, for new syntax

 -- Sam Watkins <sam@nipl.net>  Thu, 18 Aug 2005 21:43:10 +1000

brace (0.2) unstable; urgency=low

  * BR_CLEAN option for br

 -- Sam Watkins <sam@nipl.net>  Tue, 19 Jul 2005 17:52:05 +0000

brace (0.1) unstable; urgency=low

  * Added some missing dependencis to debian/control.

 -- Sam Watkins <sam@nipl.net>  Tue, 19 Jul 2005 00:57:57 +1000

brace (0.0) unstable; urgency=low

  * Initial release.



=== debian/control ===
Source: brace
Section: devel
Priority: extra
Maintainer: Sam Watkins <sam@nipl.net>
Standards-Version: 3.6.1
Build-Depends: debhelper (>= 4), libx11-dev, libxext-dev, libio-string-perl, libpng12-dev, libsdl-mixer1.2-dev, libgl1-mesa-dev

Package: brace
Architecture: any
Depends: libc6, ${perl:Depends}, libc6-dev | libc-dev, gcc (>= 3:3.3), g++ (>= 3:3.3), make, libio-string-perl, libx11-dev, libxext-dev, libpng12-dev, libsdl-mixer1.2-dev, libgl1-mesa-dev
Recommends: libncurses5-dev, msttcorefonts, fortunes, gsfonts-x11
Description: the brace programming language
 Brace is a dialect of C which looks like python.  It has two types of
 coroutines, hygenic macros, header generation, graphics and sound.
